import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.Math.*;
import java.lang.Integer;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 08.01.2008
  * @author
  */

public class SortierenGUI extends JFrame {
  // Anfang Variablen
  private SortierFeld feld;

  private JLabel jLabel_Zuweisungen = new JLabel();
  private JLabel jLabel_Vergleiche = new JLabel();
  private JTextField jTextField_Zuweisungen = new JTextField();
  private JTextField jTextField_Vergleiche = new JTextField();

  private JLabel jLabel_anzahlElemente = new JLabel();
  private JLabel jLabel_Maximum = new JLabel();
  private JTextField jTextField_anzahlElemente = new JTextField();
  private JTextField jTextField_maximum = new JTextField();
  private JButton jButton_zufallsfeldErstellen = new JButton();
  private ButtonGroup Sortieren = new ButtonGroup();
  private JButton jButton_aufsteigend = new JButton();
  private JButton jButton_absteigend = new JButton();
  private JPanel sortierenPanel = new JPanel();
  private JRadioButton jRadioButton_bubble = new JRadioButton();
  private JRadioButton jRadioButton_quick  = new JRadioButton();
  private JRadioButton jRadioButton_merge  = new JRadioButton();
  private JRadioButton jRadioButton_insert = new JRadioButton();
  private JRadioButton jRadioButton_select = new JRadioButton();

  private DefaultListModel listModel = new DefaultListModel();
  //private JList jList_zahlenliste = new JList(listModel);
  //private JScrollPane listScrollPane = new JScrollPane(jList_zahlenliste);
  private List list_zahlenliste = new List(5,false);

  
  private JLabel jLabel1 = new JLabel();
  // Ende Variablen

  public SortierenGUI(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { System.exit(0); }
    });
    int frameWidth = 300;
    int frameHeight = 372;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    
    // Anfang Komponenten

    jLabel_Zuweisungen.setBounds(8, 115, 111, 16);
    jLabel_Zuweisungen.setText("Zuweisungen:");
    jLabel_Zuweisungen.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel_Zuweisungen);
    jLabel_Vergleiche.setBounds(8, 145, 108, 16);
    jLabel_Vergleiche.setText("Vergleiche:");
    jLabel_Vergleiche.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel_Vergleiche);
    jTextField_Zuweisungen.setBounds(120, 111, 41, 24);
    jTextField_Zuweisungen.setText("0");
    cp.add(jTextField_Zuweisungen);
    jTextField_Vergleiche.setBounds(120, 141, 41, 24);
    jTextField_Vergleiche.setText("0");
    cp.add(jTextField_Vergleiche);
    
    jLabel_anzahlElemente.setBounds(8, 20, 111, 16);
    jLabel_anzahlElemente.setText("Anzahl Elemente:");
    jLabel_anzahlElemente.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel_anzahlElemente);
    jLabel_Maximum.setBounds(8, 52, 108, 16);
    jLabel_Maximum.setText("Maximum:");
    jLabel_Maximum.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel_Maximum);
    jTextField_anzahlElemente.setBounds(120, 16, 41, 24);
    jTextField_anzahlElemente.setText("10");
    cp.add(jTextField_anzahlElemente);
    jTextField_maximum.setBounds(120, 48, 41, 24);
    jTextField_maximum.setText("100");
    cp.add(jTextField_maximum);
    jButton_zufallsfeldErstellen.setBounds(8, 80, 155, 25);
    jButton_zufallsfeldErstellen.setText("Zufallsfeld erstellen");
    cp.add(jButton_zufallsfeldErstellen);

    
    jButton_zufallsfeldErstellen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton_zufallsfeldErstellenActionPerformed(evt);
      }
    });

    jButton_aufsteigend.setBounds(8, 312, 155, 25);
    jButton_aufsteigend.setFont(new Font("MS Sans Serif", Font.BOLD, 13));
    jButton_aufsteigend.setText("Sortieren");
    cp.add(jButton_aufsteigend);
    jButton_aufsteigend.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton_aufsteigendActionPerformed(evt);
      }
    });
/*
    jButton_absteigend.setBounds(88, 280, 75, 25);
    jButton_absteigend.setFont(new Font("MS Sans Serif", Font.PLAIN, 10));
    jButton_absteigend.setText("abwrts");
    cp.add(jButton_absteigend);
    jButton_absteigend.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton_absteigendActionPerformed(evt);
      }
    });
*/
    sortierenPanel.setBounds(8, 200, 153, 73);
    
    jRadioButton_bubble.setBounds(16, 216, 113, 17);
    jRadioButton_bubble.setSelected(true);
    jRadioButton_bubble.setText("Bubblesort");
    Sortieren.add(jRadioButton_bubble);
    
    jRadioButton_quick.setBounds(16, 232, 113, 17);
    jRadioButton_quick.setText("Quicksort");
    Sortieren.add(jRadioButton_quick);
    
    jRadioButton_merge.setBounds(16, 248, 113, 17);
    jRadioButton_merge.setText("Mergesort");
    Sortieren.add(jRadioButton_merge);
    
    jRadioButton_insert.setBounds(16, 264, 113, 17);
    jRadioButton_insert.setText("Insertsort");
    Sortieren.add(jRadioButton_insert);

    jRadioButton_select.setBounds(16, 280, 113, 17);
    jRadioButton_select.setText("Selectsort");
    Sortieren.add(jRadioButton_select);

    cp.add(jRadioButton_bubble);
    cp.add(jRadioButton_quick);
    cp.add(jRadioButton_merge);
    cp.add(jRadioButton_insert);
    cp.add(jRadioButton_select);
    cp.add(sortierenPanel);

    
/*
Zeile 53: Container cp = getContentPane();
Zeile 33: JList jList_zahlenliste = new JList();
Zeile 34: JScrollPane listScrollPane = new JScrollPane();
*/    
/*    listScrollPane.setBounds(176, 16, 105, 249);
    jList_zahlenliste.setBounds(176, 16, 105, 249);
    listScrollPane.add(jList_zahlenliste);
    cp.add(listScrollPane);
*/
    //cp.add(jList_zahlenliste);
    //AWT List
    list_zahlenliste.setBounds(176, 16, 105, 322);
    cp.add(list_zahlenliste);
    //AWT List Ende
    jLabel1.setBounds(8, 184, 95, 16);
    jLabel1.setText("Sortiermethode:");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Ereignisprozeduren
  public void jButton_zufallsfeldErstellenActionPerformed(ActionEvent evt) {
        //Instanzvariable initialisieren
        feld = new SortierFeld(Integer.parseInt(jTextField_anzahlElemente.getText()),Integer.parseInt(jTextField_maximum.getText()));

        // ...Werte in die jListe bernehmen
/*        for(int i=0;i<feld.getLaenge();i++) {
            listModel.addElement(feld.getFeld(i));
        }
        listScrollPane.updateUI();
*/        
        // AWT List
        list_zahlenliste.removeAll();
        for(int i=0;i<feld.getLaenge();i++) {
            list_zahlenliste.add(""+feld.getFeld(i));
        }

    }

    public void jButton_aufsteigendActionPerformed(ActionEvent evt)
    {
		feld.setZuweisungen(0);
		feld.setVergleiche(0);
        if (jRadioButton_bubble.isSelected())
            feld.bubbleSort();
        if (jRadioButton_merge.isSelected())
            feld.mergeSort(0,feld.getLaenge()-1);
        if (jRadioButton_quick.isSelected())
            feld.quickSort(0,feld.getLaenge()-1);
        if (jRadioButton_insert.isSelected())
            feld.insertSort();
        if (jRadioButton_select.isSelected())
            feld.selectSort();
        
/*      listModel.clear();
        for(int i=0;i<feld.getLaenge();i++)
        {
            listModel.addElement(feld.getFeld(i));
        }
*/
        // AWT List
        list_zahlenliste.removeAll();
        for(int i=0;i<feld.getLaenge();i++) {
            list_zahlenliste.add(""+feld.getFeld(i));
        }

        jTextField_Zuweisungen.setText(""+feld.getZuweisungen());
        jTextField_Vergleiche.setText(""+feld.getVergleiche());

    }

  public void jButton_absteigendActionPerformed(ActionEvent evt) {

  }

  // Ende Ereignisprozeduren

  public static void main(String[] args) {
    new SortierenGUI("Sortieren");
  }
}
